
/**********************Document Ready****************************************/

$(document).ready(function(){
    
    /***********************real time display********************************/
    
    var days = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'];
    
    let regionNames = new Intl.DisplayNames(['en'], {type: 'region'});
    var dayfrommon =['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat','Sun'];
    
    const convertTime12to24 = time12h => {const [time, modifier] = time12h.split(" ");let [hours, minutes] = time.split(":");if (hours === "12") {hours = "00";}if (modifier === "PM") {hours = parseInt(hours, 10) + 12;}return `${hours}:${minutes}`;};
    
    function refreshTime() {
      const timeDisplay = document.getElementById("realtime");
      const dateString = new Date().toLocaleTimeString();
      const formattedString = dateString.replace(", ", " - ");
      timeDisplay.textContent = formattedString;
    }   
    setInterval(refreshTime, 1000);
    
    function refreshukTime() {
        const timeDisplay = document.getElementById("ukTimeZone");
        var d = new Date(); /* midnight in China on April 13th */
        const dateString = d.toLocaleTimeString('en-US', { timeZone: 'Europe/London' });
        const formattedString = dateString.replace(", ", " - ");
        timeDisplay.textContent = formattedString;
    }
    setInterval(refreshukTime, 1000);
    
    function refreshusTime() {
        const timeDisplay = document.getElementById("usaTimeZone");
        var d = new Date(); /* midnight in China on April 13th */
        const dateString = d.toLocaleTimeString('en-US', { timeZone: 'America/New_York' });
        const formattedString = dateString.replace(", ", " - ");
        timeDisplay.textContent = formattedString;
    }
    setInterval(refreshusTime, 1000);  
    
    function refreshghTime() {
        const timeDisplay = document.getElementById("ghTimeZone");
        var d = new Date(); /* midnight in China on April 13th */
        const dateString = d.toLocaleTimeString('en-US', { timeZone: 'Africa/Accra' });
        const formattedString = dateString.replace(", ", " - ");
        timeDisplay.textContent = formattedString;
    }
    setInterval(refreshghTime, 1000);
    
    function refreshinTime() {
        const timeDisplay = document.getElementById("inTimeZone");
        var d = new Date(); /* midnight in China on April 13th */
        const dateString = d.toLocaleTimeString('en-US', { timeZone: 'Asia/Kolkata' });
        const formattedString = dateString.replace(", ", " - ");
        timeDisplay.textContent = formattedString;
    }
    setInterval(refreshinTime, 1000);
    
    /*****************************Display upcoming Student *****************/
    
    getUpcomingClass();
    function getUpcomingClass(){
        $('#ucStart').prop("disabled",true);
        $type = "upcomingclass";
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{"type":$type},
            success:function(data){
                $.each(data,function(i,row){
                    $date = getdateformat(row[6]);
                    var date = new Date(row[6]);
                    var day = date.getDay();
                    var datecount = date.getDate();
                    var month = date.getMonth() + 1;
                    var year = date.getFullYear();
                    if(row[30].indexOf('zoom') != -1){
                        $details = row[30];
                    }else{
                        $details = "startclass?/"+row[0]+"/"+row[30];
                    }
                    $country = regionNames.of(row[18]);
                    $datetocheckst = gettime(month,datecount,year,row[7]);
                    $datetochecked = gettime(month,datecount,year,row[8]);
                    const timezone = Intl.DateTimeFormat().resolvedOptions().timeZone;
                    const localstartdatetime = getlocaltime($datetocheckst,timezone).split(", ");
                    const localenddatetime = getlocaltime($datetochecked,timezone).split(", ");
                    const studentstartdatetime = getlocaltime($datetocheckst,row[29]).split(", ");
                    const studentenddatetime = getlocaltime($datetochecked,row[29]).split(", ");
                    $localdaydate = localstartdatetime[0]+", "+localstartdatetime[2]+" - "+localenddatetime[2];
                    $studentdaydate = studentstartdatetime[0]+", "+studentstartdatetime[2]+" - "+studentenddatetime[2];
                    var localdate = new Date(localstartdatetime);
                    var timenow = new Date();
                    var timematch = localdate;
                    timematch.setMinutes(timematch.getMinutes() - 10);
                    if( timenow >= timematch){
                        $('#ucStart').prop("disabled",false);
                    }
                    $localdatetime = localdate.getDate()+"-"+(localdate.getMonth()+1)+"-"+localdate.getFullYear();
                    $('#ucDate').text($localdatetime);
                    $('#ucTime').text($localdaydate);
                    $('#ucCourse').text(row[5]);
                    $('#ucCountry').text($country);
                    $('#ucSession').text(row[31]);
                    $('#classtype').text(row[32]);
                    $('#ucaTime').text($studentdaydate);
                    $('#ucStartlink').attr('href',$details);
                    $typedd = "Teacher details";
                    getteacherdetails(row[3],$typedd);
                });
            },
            error:function(data){
                $('#upcomingclassdetails').empty();
                $('#upcomingclassdetails').append(
                      '<div class="mb-0"><h2 class="card-heading text-center mb-0">Upcoming Class</h2></div><span class="question-tag-new" id="classtype">No Class</span><div class="tab-content best_teacher_tab_content mb-4"><div class="d-flex flex-column text-center p-5 m-5"><div class="custom-radio mr-5"><h6><span class="pr-2 pl-2">No Upcoming Class</span></h6></div></div></div>'+
                        '<div class="tab-content best_teacher_tab_content"><div class="d-flex flex-column flex-row p-2 m-2"><button class="btn main-btn btn-paid" id="ucSchedule">Schedule class</button></div></div>'
                );
            }
        });
    }
    
    function getdateformat(orginaldate) { 
        var date = new Date(orginaldate);
        var day = date.getDate();
        var month = date.getMonth() + 1;
        var year = date.getFullYear();
        if (day < 10) {
            day = "0" + day;
        }
        if (month < 10) {
            month = "0" + month;
        }
        var formateddate =  day + "-" + month + "-" + year; 
        return formateddate;
    }
    
    function gettime(month,datecount,year,time){
        $datetocheck = month+"-"+datecount+"-"+year+" "+time+" UTC";
        return $datetocheck;
    }
    
    function getlocaltime($datetocheckst,timezone){
        $datetime = new Date($datetocheckst).toLocaleString('en-US', { timeZone: timezone, weekday: 'long', year: 'numeric', month: 'numeric', day: 'numeric',hour12:true,hour:'numeric',minute:'numeric'});
        return $datetime;
    }
    
    // /*****************************Schedule class*************************/
    
    $(document).on('click','#ucSchedule',function(){
        $(location).prop('href', 'scheduler');
    });
    
    
    /*****************************Display Assignment**********************/
    
    getpassign();
    function getpassign(){
        $type = "Pending Assignment";
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": $type
            },
            success:function(data){
                $('#passign').text(data);
            },
            error:function(data){
            }
        });
    }
    
    /*****************************Display Assessment**********************/
    
    getpassess();
    function getpassess(){
        $type = "Pending Assessment";
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": $type
            },
            success:function(data){
                $('#passess').text(data);
            },
            error:function(data){
            }
        });
    }
    
    /*****************************Display pastclass**********************/
    
    getpastclass();
    function getpastclass(){
        $type = "Syllabus Completed";
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": $type
            },
            success:function(data){
                $('#scomp').text(data);
            },
            error:function(data){
            }
        });
    }
    
    /*****************************Display health check**********************/
    
    gethealthcheck();
    function gethealthcheck(){
        $type = "System health check";
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": $type
            },
            success:function(data){
                $('#syshc').text(data+"%");
            },
            error:function(data){
            }
        });
    }
    
    /*****************************Display health check**********************/
    
    getweeklyschedule();
    function getweeklyschedule(){
        var curr = new Date();
        day = curr.getDay();
        firstday = new Date(curr.getTime() - 60*60*24* 0*1000);
        lastday = new Date(firstday.getTime() + 60 * 60 *24 * 6 * 1000);
        $firstdated = getdateformat(firstday);
        $lastdated = getdateformat(lastday);
        $firstdayweek = $firstdated.split("-");
        $lastdayweek = $lastdated.split("-");
        $firstdate = $firstdayweek[2]+"-"+$firstdayweek[1]+"-"+$firstdayweek[0];
        $lastdate = $lastdayweek[2]+"-"+$lastdayweek[1]+"-"+$lastdayweek[0];
        $action = "Get Weekly Schedule";
        const timezone = Intl.DateTimeFormat().resolvedOptions().timeZone;
        getAllSchedule($firstdate,$lastdate,$action,timezone);
    }
    
    function getAllSchedule($firstdate,$lastdate,$action,timezone){
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": $action,
                "firstdate": $firstdate,
                "lastdate": $lastdate,
                "stimezone":timezone
            },
            success:function(data){
                $.each(data,function(i,row){
                    var date = new Date(row[6]);
                    var day = date.getDay();
                    var datecount = date.getDate();
                    var month = date.getMonth() + 1;
                    var year = date.getFullYear();
                    $rowid = row[3]+"-"+i;
                    $datetimenow = new Date();
                    $datetocheckst = gettime(month,datecount,year,row[7]);
                    $datetochecked = gettime(month,datecount,year,row[8]);
                    const localstartdatetime = getlocaltime($datetocheckst,timezone).split(", ");
                    const localenddatetime = getlocaltime($datetochecked,timezone).split(", ");
                    $timetotest = new Date(localstartdatetime[1]+" "+localstartdatetime[2]);
                    $localdaydate = localstartdatetime[2]+" - "+localenddatetime[2];
                    $timetotest.setHours($timetotest.getHours() + 1);
                    if($datetimenow >= $timetotest){
                        if(row[16] == ""){
                            $status = "Slot Expired";
                        }else{
                            $status = row[16];
                        }
                    }else{
                        if(row[16] == ""){
                            $status = "Upcoming";
                        }else{
                            $status = row[16];
                        }
                    }
                    $(".allBookingaday").append(
                        '<tr class="rowspan-tr" id="'+$rowid+'">'+
                            '<td class="teacherUP text-center"><img src="" alt="image"></td>'+
                            '<td class="teachername"></td>'+
                            '<td>'+row[5]+'</td>'+
                            '<td>'+getdateformat(localstartdatetime[1])+'</td>'+
                            '<td>'+localstartdatetime[0]+'</td>'+
                            '<td>'+$localdaydate+'</td>'+
                            '<td>'+$status+'</td>'+
                        '</tr>'
                    );
                    $actiond = "getteacherweek";
                    getteacherdetails(row[3],$actiond,i)
                });
            },
            error:function(data){
            }
        });
    }

    
    /*******************************fetch teacher****************************/
    
    function getteacherdetails(tusername,$actiond,i){
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": $actiond,
                "tusername": tusername
            },
            success:function(data){
                if($actiond == "getteacherweek"){
                    $profilepath = '../admin/assets/uploads/'+data['oname']+"/"+data['profilepic'];
                    const getfilename = checkstatus($profilepath);
                    if(getfilename == "200" && data['profilepic'] != ""){
                       $profilepath = '../admin/assets/uploads/'+data['oname']+"/"+data['profilepic'];
                    }else{
                       if(data['gender'] == "M"){
                           $profilepath = '../admin/assets/img/adminAllNew/boyS.jpeg';
                       }else{
                           $profilepath = '../admin/assets/img/adminAllNew/girlS.jpeg';
                       }
                       
                    }
                    $id = tusername+"-"+i;
                    $('#'+$id).children(".teachername").text(data['fname']+" "+data['lname']);
                    $('#'+$id).children(".teacherUP").children('img').prop('src',$profilepath);
                }else{
                    $('#ucteacher').text(data['fname']+" "+data['lname']);
                    $('#ucteacher').attr('class', tusername);
                }    
            },
            error:function(data){
            }
        });
    }
    
    /*****************************file path*************************/
    
    function checkstatus(path){
        var http = new XMLHttpRequest();
        http.open('HEAD', path, false);
        http.send();
        return http.status;
    }
    
    /*****************************Prospect Click*************************/
    
    $('#passessment').on("click",function(){
        $(location).prop('href', 'assessment');
    });
    
    // /*****************************Student Click*************************/
    
    $('#passignment').on("click",function(){
        $(location).prop('href', 'assignment');
    });
    
    // /*****************************Course Click*************************/
    
    $('#scompleted').on("click",function(){
        $(location).prop('href', 'pastclasses');
    });
    
    // /*****************************report Click*************************/
    
    $('#shc').on("click",function(){
        $(location).prop('href', 'siteconfiguration');
    });
    
    /*****************************assesment Click*************************/
    
    $('#passessment').on("click",function(){
        $(location).prop('href', 'assessment');
    });
    
    /*****************************my sub Click*************************/
    
    $('.mstrigger').on("click",function(){
        $(location).prop('href', 'personalprofile');
    });
    
    /*****************************prog report Click*************************/
    
    $('.prtrigger').on("click",function(){
        $(location).prop('href', 'progressreport');
    });
    
    /*****************************schedule more Click*************************/
    
    $('.smtrigger').on("click",function(){
        $(location).prop('href', 'scheduler');
    });
                                             
});